package it.html.oauth.web;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import it.html.oauth.OAuthServiceProvider;
import it.html.oauth.OAuthServiceV2Provider;
import it.html.oauth.model.OAuthUser;
import it.html.oauth.model.User;


@Controller
@RequestMapping(RestURI.LOGIN_URL_FACEBOOK)
public class FacebookLoginController extends BaseLoginController {
	
	@RequestMapping(value = RestURIAction.ACTION_USER)
	@ResponseBody
	public User getUser(@RequestParam(value = "code", required = true) String code) {
		OAuthUser user = serviceProvider.getOAuthUser(code);
		return loginService.login(user);	
	}
	
	@RequestMapping(value = RestURIAction.ACTION_CALLBACK)
	@ResponseBody
	public String loginCallback(@RequestParam(value = "code", required = true) String code) throws Exception {		
		return "OK";	
	}
	
	@Autowired
	@Qualifier("facebookServiceProvider")
	private OAuthServiceV2Provider serviceProvider;

	@Override
	protected OAuthServiceProvider getServiceProvider() {
		return serviceProvider;
	}
	
}
